ClassFile.ConstantPoolSharingOption (Java SE 25 & JDK 25)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: ConstantPoolSharingOption
Keywords: java.lang.classfile.ClassFile.ConstantPoolSharingOption class

# Enum Class ClassFile.ConstantPoolSharingOption

java.lang.Object
java.lang.Enum<ClassFile.ConstantPoolSharingOption>
java.lang.classfile.ClassFile.ConstantPoolSharingOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.ConstantPoolSharingOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.ConstantPoolSharingOption extends Enum<ClassFile.ConstantPoolSharingOption> implements ClassFile.Option
Option describing whether to extend from the original constant pool when transforming a `class` file. The default is `SHARED_POOL` to extend from the original constant pool.

This option affects all overloads of `transformClass`. Extending from the original constant pool keeps the indices into the constant pool intact, which enables significant optimizations in processing time and minimizes differences between the original and transformed `class` files, but may result in a bigger transformed `class` file when many elements of the original `class` file are dropped and many original constant pool entries become unused.

An alternative to this option is to use `ClassFile.build(ClassEntry, ConstantPoolBuilder, Consumer)` directly. It allows extension from arbitrary constant pools, and may be useful if a built `class` file reuses structures from multiple original `class` files.

Since:
  24
See Also:
  - `ConstantPoolBuilder`
  - `ClassFile.build(ClassEntry, ConstantPoolBuilder, Consumer)`
  - `ClassFile.transformClass(ClassModel, ClassTransform)`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NEW_POOL`
  Creates a new constant pool when transforming the `class` file.
  `SHARED_POOL`
  Extend the new constant pool from the original constant pool when transforming the `class` file.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.ConstantPoolSharingOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.ConstantPoolSharingOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SHARED_POOL

    public static final ClassFile.ConstantPoolSharingOption SHARED_POOL
    Extend the new constant pool from the original constant pool when transforming the `class` file.

    These two transformations below are equivalent:

        ClassModel originalClass = ...
        ClassDesc resultClassName = ...
        ClassTransform classTransform = ...
        var resultOne = ClassFile.of(ConstantPoolSharingOption.SHARED_POOL)
                .transformClass(originalClass, resultClassName, classTransform);
        var resultTwo = ClassFile.of().build(resultClassName, ConstantPoolBuilder.of(originalClass),
                clb -> clb.transform(originalClass, classTransform));

    See Also:
      - `ConstantPoolBuilder::of(ClassModel)`

  - ### NEW_POOL

    public static final ClassFile.ConstantPoolSharingOption NEW_POOL
    Creates a new constant pool when transforming the `class` file.

    These two transformations below are equivalent:

        ClassModel originalClass = ...
        ClassDesc resultClassName = ...
        ClassTransform classTransform = ...
        var resultOne = ClassFile.of(ConstantPoolSharingOption.NEW_POOL)
                .transformClass(originalClass, resultClassName, classTransform);
        var resultTwo = ClassFile.of().build(resultClassName, ConstantPoolBuilder.of(),
                clb -> clb.transform(originalClass, classTransform));

    See Also:
      - `ConstantPoolBuilder::of()`

- ## Method Details

  - ### values

    public static ClassFile.ConstantPoolSharingOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.ConstantPoolSharingOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null